package HDBtools;
#------------------------------------------------------------------------------
#
# VAGINUS Common Perl Script
#
#------------------------------------------------------------------------------
#------------------------------------------------------------------------------
# CGI 
#------------------------------------------------------------------------------
sub cgi_set {

	my($str)	= @_;
	my %cgi;

	my(@part)	= split('&', $str);
	my $part_data;

	foreach $part_data(@part) {

		my($variable, $value)	= split('=', $part_data);
		$value	=~ tr/+/ /;
		$value	=~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("C", hex($1))/eg;
		&jcode'convert(*value, 'euc');
		# <> Ϥϵʤ
		$value	=~ s/>/&gt;/g;
		$value	=~ s/</&lt;/g;
		# TAB ɤϤ
		$value	=~ s/\t/ /g;
		# ԥɤ LF 
		$value	=~ s/\015\012/\012/g;
		$value	=~ s/\015/\012/g;
		$cgi{$variable}	= $value;

	}

	return %cgi;

}

#------------------------------------------------------------------------------
# HTML إå
#------------------------------------------------------------------------------
sub header_html {

	my($options, $title)	= @_;
	my @html;

	if ($options eq '') {
		$options	= " bgcolor=\"#ffffff\"";
	}
	else {
		$options	= join '', ' ', $options;
	}

	push @html, "Content-type: text/html\n\n";
	push @html, "<html>\n";
	push @html, "<head>\n";
	push @html, "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=euc\">\n";
	push @html, "<title>$title</title>\n";
	push @html, "</head>\n";
	push @html, "<body", $options, ">\n";

	push @html, "<center>\n";

	return @html;

}

#------------------------------------------------------------------------------
# HTML ȥ
#------------------------------------------------------------------------------
sub title_html {

	my($year, $month)	= @_;
	my @html;

	push @html, "<br><p>\n";
	push @html, "<font size=\+2><b>$year ǯ $month  HDBENCH </b></font>\n";
	push @html, "<br><p>\n";
	push @html, "<hr>\n";

	return @html;

}

#------------------------------------------------------------------------------
# HTML եå
#------------------------------------------------------------------------------
sub footer_html {

	my($date)	= @_;
	my @html;

	push @html, "<hr>\n";
	push @html, "\[<a href=\"/hdbench/index.html\">Top Index</a>]\n";
	push @html, "<hr>\n";
	push @html, "<i><a href=\"mailto:root\@localhost\">";
	push @html, "PC-GP ¹԰Ѱ</a> $date</i>\n";
	push @html, "</center>\n";

	push @html, "</body>\n";
	push @html, "</html>\n";

	return @html;

}

#------------------------------------------------------------------------------
# ̥ȥåץ
#------------------------------------------------------------------------------
sub topscore_update {

	my($scoreFile, $topFile, $type)	= @_;

	# ɤ߹
	open (IN, "$scoreFile$type");
	my(@rank)	= <IN>;
	close(IN);

	my @top;

	foreach my $dataline(@rank) {

		my(@rankline)	= split /\t/, $dataline;

		for ($i = 0;$i < 14; $i++) {
			chomp $rankline[$i + 7];
			chomp $top[$i];
			if (($rankline[$i + 7] > $top[$i]) || ($top[$i] eq '')) {
				$top[$i]	= $rankline[$i + 7];

			}
		}

	}

	open (OUT, ">$topFile$type");
	print OUT (join "\n", @top);
	close(OUT);

}

#------------------------------------------------------------------------------
# HDBENCH ̤ʬ򡦿ͤơ֥˥å
#------------------------------------------------------------------------------
sub list_split {

	my($listorg)	= @_;
	my($cpu, $os, $video);
	my @score;

	my(@list)	= split /\n/, $listorg;

	foreach my $dataline(@list) {

		if ($dataline =~ /^Processor\s*(.*)/) {
			$cpu	= (split /\[/, $1, 2)[0];
		}
		elsif ($dataline =~ /^OS\s*(.*)/) {
			$os	= $1;
		}
		elsif ($dataline =~ /^VideoCard\s*(.*)/) {
			$video	= $1;
		}
		elsif ($dataline =~ /^\s*\d/) {

			my(@temp)	= split /\s/, $dataline;
			foreach my $dataline (@temp) {
				if ($dataline ne '') {
					push @score, $dataline;
				}
			}

		}

	}

	return $cpu, $os, $video, @score;

}

#------------------------------------------------------------------------------
# END
#------------------------------------------------------------------------------
1;
