#!/usr/local/bin/perl
#
# hdbench3_rank.cgi
#
#    HDBENCH 3.X η̤ưסʥ󥯻ȡ
#
#    2000.05.02 SHINODA MasanoriVAGINUS HDBENCH кѰ
#

require 'jcode.pl';
require 'IHCtools.pl';
require 'HDBtools.pl';

my(%cgi)	= &init_proc;

$Dpw	= 'passw0rd';
$Dviewtime;	# 򥹥Ȥ
$Fdir	= "data$cgi{'year'}$cgi{'month'}";	# ǡǼǥ쥯ȥ

$Poneview	= './hdbench3_data.cgi';

# ǯå
$Dyear	= $cgi{'year'};
$Dmonth	= $cgi{'month'};
$Fscore	= "$Fdir/score$Dyear$Dmonth\.dat";
$Ftop	= "$Fdir/topscore$Dyear$Dmonth\.dat";
$Fdeny	= "$Fdir/deny\.dat";

&main_proc(%cgi);

#------------------------------------------------------------------------------
# form ͤ
#------------------------------------------------------------------------------
sub init_proc {

	my %cgi;
	my $str;

	if ($ENV{'REQUEST_METHOD'} eq "POST") {
		read(STDIN, $str, $ENV{'CONTENT_LENGTH'});
	}
	else {
		$str	= $ENV{'QUERY_STRING'};
	}

	if ($str ne '') {

		%cgi	= &HDBtools'cgi_set($str);

	}

	return %cgi;

}

#------------------------------------------------------------------------------
# ᥤ
#------------------------------------------------------------------------------
sub main_proc {

	my(%cgi)	= @_;

	print (&HDBtools'header_html("bgcolor=\"#ffffd0\"", "󥭥ɽ"));
	print (&HDBtools'title_html($Dyear, $Dmonth));

	if (((&date_check) == 1) || ($Dpw eq $cgi{'pw'})) {
		print (&rank_html
			($cgi{'year'}, $cgi{'month'}, $cgi{'pw'}, $cgi{'type'}));
	}
	else {
		&dontview_html();
	}

	print (&HDBtools'footer_html(&IHCtools'today_set));

}

#------------------------------------------------------------------------------
# ɽ
#------------------------------------------------------------------------------
sub rank_html {

	my($year, $month, $pw, $type)	= @_;
	my @html;

	push @html, "<br><p>\n";
	push @html, "<table border=\"1\">\n";
	push @html, "<tr bgcolor=\"#cbffcb\">\n";
	push @html, "<th><br></th><th>Owner</th><th>PC-Name</th><th>OS</th>\n";
	push @html, "<th>CPU</th><th>VGA</th><th>ALL</th><th>Int<br>Float</th>\n";
	push @html, "<th>MemR<br>MemW</th><th>MemRW</th><th>DD</th><th>Rect<br>";
	push @html, "Text</th>\n";
	push @html, "<th>Ellipse<br>BitBlt</th><th>Read<br>Write</th><th>Copy";
	push @html, "</th>\n";
	push @html, "<th></th></tr>\n";

	push @html, (&rank_read($year, $month, $pw, $type));

	push @html, "</table>\n";
	push @html, "<br><p>\n";

	return @html;

}

#------------------------------------------------------------------------------
# 󥯥եɤ߹ߡHTML
#------------------------------------------------------------------------------
sub rank_read {

	my($year, $month, $pw, $type)	= @_;
	my @html;

	# 󥭥󥰥եɤ߹
	open (IN, "$Fscore$type");
	my(@rank)	= <IN>;
	close(IN);

	my %rankline;
	my $num;	# ǹ
	my $subnum;	# Ʊοͤ⤤뤫

	$subnum	= 0;
	foreach my $dataline(@rank) {

		$subnum++;
		@temp	= split /\t/, $dataline;
		chomp $temp[7];
		$num	= &zero_set(8, $temp[7]);
		$rankline{"$num $subnum"}	= $dataline;

	}

	# ǹɤ߹
	open (IN, "$Ftop$type");
	my(@top)	= <IN>;
	close(IN);

	# ALL 礭¤ؤ
	my(@keys)	= keys %rankline;
	@keys	= sort @keys;
	@keys	= reverse @keys;

	my $i	= 0;
	my $beforeAll	= 0;
	my $beforeRank	= 1;
	foreach my $dataline(@keys) {

		$i++;

		my(@score)	= split /\t/, $rankline{$dataline};

		push @html, "<tr bgcolor=\"#ffffff\">\n";
		if ($score[7] == $beforeAll) {
			push @html, "<td>$beforeRank</td>";
		}
		else {
			push @html, "<td>$i</td>";
			$beforeRank	= $i;
		}
		push @html, "<td>$score[0]<br>$score[1]</td>";
		my($mcname)	= &jpn_enc($score[3]);
		push @html, "<td><a href=\"$Poneview\?year=$year&month=$month&pw=$pw";
		push @html, "&fn=$score[21]&mn=$mcname\">$score[3]</a></td>\n";
		push @html, "<td>$score[5]</td><td>$score[4]</td><td>$score[6]</td>\n";
		chomp $top[0];
		push @html, "<td align=\"right\">";
		if ($top[0] <= $score[7]) {
			push @html, "<font color=\"#ff0000\">$score[7]</font></td>";
		}
		else {
			push @html, "$score[7]</td>";
		}
		chomp $top[1];
		push @html, "<td align=\"right\">";
		if ($top[1] <= $score[8]) {
			push @html, "<font color=\"#ff0000\">$score[8]</font><br>";
		}
		else {
			push @html, "$score[8]<br>";
		}
		chomp $top[2];
		if ($top[2] <= $score[9]) {
			push @html, "<font color=\"#ff0000\">$score[9]</font></td>";
		}
		else {
			push @html, "$score[9]</td>";
		}
		chomp $top[3];
		push @html, "<td align=\"right\">";
		if ($top[3] <= $score[10]) {
			push @html, "<font color=\"#ff0000\">$score[10]</font><br>";
		}
		else {
			push @html, "$score[10]<br>";
		}
		chomp $top[4];
		if ($top[4] <= $score[11]) {
			push @html, "<font color=\"#ff0000\">$score[11]</font></td>";
		}
		else {
			push @html, "$score[11]</td>";
		}
		chomp $top[5];
		push @html, "<td align=\"right\">";
		if ($top[5] <= $score[12]) {
			push @html, "<font color=\"#ff0000\">$score[12]</font></td>";
		}
		else {
			push @html, "$score[12]</td>";
		}
		chomp $top[6];
		push @html, "<td align=\"right\">";
		if ($top[6] <= $score[13]) {
			push @html, "<font color=\"#ff0000\">$score[13]</font></td>";
		}
		else {
			push @html, "$score[13]</td>";
		}
		chomp $top[7];
		push @html, "<td align=\"right\">";
		if ($top[7] <= $score[14]) {
			push @html, "<font color=\"#ff0000\">$score[14]</font><br>";
		}
		else {
			push @html, "$score[14]<br>";
		}
		chomp $top[8];
		if ($top[8] <= $score[15]) {
			push @html, "<font color=\"#ff0000\">$score[15]</font></td>";
		}
		else {
			push @html, "$score[15]</td>";
		}
		chomp $top[9];
		push @html, "<td align=\"right\">";
		if ($top[9] <= $score[16]) {
			push @html, "<font color=\"#ff0000\">$score[16]</font><br>";
		}
		else {
			push @html, "$score[16]<br>";
		}
		chomp $top[10];
		if ($top[10] <= $score[17]) {
			push @html, "<font color=\"#ff0000\">$score[17]</font></td>";
		}
		else {
			push @html, "$score[17]</td>";
		}
		chomp $top[11];
		push @html, "<td align=\"right\">";
		if ($top[11] <= $score[18]) {
			push @html, "<font color=\"#ff0000\">$score[18]</font><br>";
		}
		else {
			push @html, "$score[18]<br>";
		}
		chomp $top[12];
		if ($top[12] <= $score[19]) {
			push @html, "<font color=\"#ff0000\">$score[19]</font></td>";
		}
		else {
			push @html, "$score[19]</td>";
		}
		chomp $top[13];
		push @html, "<td align=\"right\">";
		if ($top[13] <= $score[20]) {
			push @html, "<font color=\"#ff0000\">$score[20]</font></td>";
		}
		else {
			push @html, "$score[20]</td>\n";
		}
		chomp $score[23];
		if ($score[23] eq '') {
			push @html, "<td align=\"center\">-</td>\n";
		}
		else {
			push @html, "<td align=\"center\">$score[23]</td>\n";
		}

		push @html, "</tr>\n";

		$beforeAll	= $score[7];

	}

	return @html;

}

#------------------------------------------------------------------------------
# HTML ޤˤᤤΤͤ
#------------------------------------------------------------------------------
sub dontview_html {

	print "<br><p>\n";
	print "<font size=\+1 color=\"#ff0000\"><b>";
	print (&date_read);
	print "ޤ<br>Ф餯Ԥ</b></font>\n";
	print "<br><p>\n";

}

#------------------------------------------------------------------------------
# Ƭ䴰ʥȥȤƻѤΤ
#------------------------------------------------------------------------------
sub zero_set {

	my($keta, $num)	= @_;

	my $i;

	$keta	= $keta - (length $num);
	for($i = 1; $i <= $keta; $i++) {
		$num	= '0' . $num;
	}

	return $num;

}

#------------------------------------------------------------------------------
# Υå
#------------------------------------------------------------------------------
sub date_check {

	chomp $temp[0];
	# 1...հʹ -1...ޤ
	if ((&date_read) lt (&IHCtools'today_set)) {
		return 1;
	}
	else {
		return -1;
	}

}

#------------------------------------------------------------------------------
# 
#------------------------------------------------------------------------------
sub date_read {

	open (IN, $Fdeny);
	my(@temp)	= <IN>;
	close(IN);

	if ($temp[0] eq '') {
		return '9999/99/99 99:99';
	}
	else {
		return $temp[0];
	}

}

#------------------------------------------------------------------------------
# ܸΰ򥨥󥳡
#------------------------------------------------------------------------------
sub jpn_enc {

	my($dataline)	= @_;

	$dataline	=~ s/([^0-9A-Za-z_ ])/'%'.unpack('H2',$1)/ge;
	$dataline	=~ s/\s/+/g;

	return $dataline;

}

#------------------------------------------------------------------------------
# END
#------------------------------------------------------------------------------
